
!WeakKeyDictionary methodsFor: '*system overrides for ma object serialization-overrides' stamp: 'cmm 6/10/2004 15:56'!
associationsDo: aBlock 
	"Evaluate aBlock for each of the receiver's elements (key/value 	
	associations)."

	super associationsDo:
		[ : eachAssoc |  | eachKey |
		eachKey _ eachAssoc key.  "reference to ensure no GC"
		eachKey ifNotNil: [ aBlock value: eachAssoc ] ]! !

!Class methodsFor: '*system overrides for ma object serialization-overrides' stamp: 'cmm 6/29/2004 00:29'!
rename: aString 
	"The new name of the receiver is the argument, aString."

	| oldName newName |
	(newName _ aString asSymbol) ~= (oldName _ self name)
		ifFalse: [^ self].
	(self environment includesKey: newName)
		ifTrue: [^ self error: newName , ' already exists'].
	(Undeclared includesKey: newName)
		ifTrue: [self inform: 'There are references to, ' , aString printString , '
from Undeclared. Check them after this change.'].
	name _ newName.
	self environment renameClass: self from: oldName! !

!SystemDictionary methodsFor: '*system overrides for ma object serialization-overrides' stamp: 'cmm 6/29/2004 10:08'!
renameClass: aClass from: oldName 
	"Rename the class, aClass, to have the title newName."
	| oldref i newName category |
	newName := aClass name.
	category := aClass category.
	SystemOrganization classify: newName under: aClass category.
	SystemOrganization removeElement: oldName.
	oldref _ self associationAt: oldName.
	self removeKey: oldName.
	oldref key: newName.
	self add: oldref.  "Old association preserves old refs"
	(Array with: StartUpList with: ShutDownList) do:
		[:list |  i _ list indexOf: oldName ifAbsent: [0].
		i > 0 ifTrue: [list at: i put: newName]].
	self flushClassNameCache.
	SystemChangeNotifier uniqueInstance classRenamed: aClass from: oldName to: newName inCategory: category! !

!Dictionary methodsFor: '*system overrides for ma object serialization-overrides' stamp: 'cmm 6/8/2004 20:50'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	key ifNil: [ self error: 'Dictionaries cannot meaningfully key by nil.' ].
	index _ self findElementOrNil: key.
	assoc _ array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!ClassRenameFixTest methodsFor: '*system overrides for ma object serialization-overrides' stamp: 'cmm 6/29/2004 00:34'!
testRenameClassUsingSystemDictionary
	"self run: #testRenameClassUsingSystemDictionary"

	self renameClassUsing: [:class :newName | class rename: newName].! !
